//+-------------------------------------------------------------------------+
//|ZigZag                                           |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|               "Parameters for ZigZag"                                   |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|ExtIndicator -   ,                |
//|                                                |
//|           0 - Zigzag  , ,               |
//|                                                         |
//|           1 - Zigzag ,                                            |
//|           2 -     Ensign                   |
//|           3 - ZigZag Ensign    minBars              |
//|           4 - ZigZag,  tauber                                 |
//|           5 -                                 |
//|           6 - DT-ZigZag   ZigZag_new_nen3.mq4.        |
//|                ZigZag                                        |
//|           7 - DT-ZigZag   DT_ZZ.mq4 ( klot)           |
//|           8 - DT-ZigZag   CZigZag.mq4 ( Candid)       |
//|          10 - DT-ZigZag   Swing_zz -  ExtIndicator=5         |
//|                 DT                                               |
//|          11 -    Gartley      |
//|               ZigZag                                                    |
//|          12 - ZigZag,  Talex                                  |
//|          13 - SQZZ ,                           |
//|          14 - ZZ_2L_nen,  wellx (  - nen)    |
//|                                                                         |
//|ParametresZZforDMLEWA -                             |
//|             minBars - ExtBackstep                                       |
//|               ExtIndicator=0  ExtIndicator=6,                |
//|                DML&EWA                              |
//|                                                                         |
//|          1 - minBars=5   ExtBackstep=8                                  |
//|          2 - minBars=8   ExtBackstep=13                                 |
//|          3 - minBars=13  ExtBackstep=21                                 |
//|          4 - minBars=21  ExtBackstep=34                                 |
//|          5 - minBars=34  ExtBackstep=55                                 |
//|          6 - minBars=55  ExtBackstep=89                                 |
//|          7 - minBars=89  ExtBackstep=144                                |
//|          8 - minBars=144 ExtBackstep=233                                |
//|                                                                         |
//|          0 -                                 |
//|              minBars - ExtBackstep                                      |
//|                                                                         |
//|minBars -   (  )                     |
//|minSize -     (  )     |
//|                                                                         |
//|ExtBackstep -    ZigZag  MT4                       |
//|noBackstep -     ExtBackstep        |
//|                                              |
//| ExtIndicator=0, ExtIndicator=6  ExtIndicator=11                        |
//|                                                                         |
//|RecoverFiltr -    ,         |
//|                ExtBackstep.                                   |
//|                                                                         |
//|GrossPeriod -  ,    ( ),   |
//|       ZigZag   DT-ZigZag      |
//|                                                                         |
//|minPercent -   ( ,  0.5)          |
//|                -                    |
//|              minSize=0                                            |
//|                                                                         |
//|ExtPoint=11 -        Talex               |
//|                                                                         |
//|StLevel -    (wellx)                                 |
//|BigLevel -    (wellx)                                |
//|auto -     StLevel  BigLevel        |
//|minBar -  %   StLevel                                  |
//|maxBar -  %   BigLevel                                 |
//|                                                                         |
//|                                                                         |
//|ExtStyleZZ - = true -    ZigZag         |
//|             = false - Zigzag                |
//|                                                                         |
//|ExtMaxBar -   ,           |
//|            0 -                        |
//|ExtMinBar -    ,       |
//|                                                                   |
//|                                                                         |
//|ExtNumberPeak -    ZigZag   1          |
//|ExtNumberPeak10 -       10    |
//|ExtNumberPeakLow -     Low   High  Low             |
//|ExtNumberPeakColor -                                            |
//|ExtNumberPeakFontSize -                                       |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|               "Parameters for fibo Levels"                              |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|ExtFiboDinamic -     .               |
//|                              |
//|                 ZigZag-a.                                               |
//|                                                                         |
//|ExtFiboStatic -                      |
//|                                                                         |
//|ExtFiboStaticNum -   ZigZag-a,          |
//|                     . 1<ExtFiboStaticNum<=9   |
//|                                                                         |
//|ExtFiboCorrectionExpansion = false -                   |
//|                           = true  -                  |
//|                                                                         |
//|ExtFiboD  ExtFiboS -      .        |
//|                                                                         |
//|ExtFiboStyle -                         |
//|                                                                         |
//|ExtFiboWidth -                       |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|               "Parameters for Pesavento Patterns"                       |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|ExtPPWithBars - ,               |
//|                                                        |
//|                                                                         |
//|             0 -         |
//|                                                                         |
//|             1 -     ,     |
//|                 "" ( )                    |
//|                                                                         |
//|             2 -               |
//|                   ,            |
//|                 "" ( )                      |
//|                                                                         |
//|             3 -                |
//|                 .        |
//|                             |
//|                                       |
//|                                                                         |
//|             4 -   ,          |
//|                              |
//|                                                      |
//|                                                                         |
//|             7 -           |
//|                       |
//|                  .         |
//|                    .                |
//|                                                                         |
//|             8 -           |
//|                                                                         |
//|             9 -                     |
//|                                                              |
//|                                                                         |
//|            10 -     ,      |
//|                                                                         |
//|ExtHidden - 0 -      .                |
//|            1 -     ,         |
//|                 >0.14  <5.                                   |
//|            2 -     ,                |
//|                   ( 0.447, 0.886, 2.236, 3,14,     |
//|                3,618    Gartley)                  |
//|            3 -  ,    2               |
//|                                                    |
//|            4 -           |
//|            5 -   .   ZigZag            |
//|                   Gartley                                |
//|                                                                         |
//|ExtFractal -   (, ),             |
//|                                     |
//|                                                                         |
//|ExtFractalEnd -  ,                 |
//|                             |
//|                 ExtFractalEnd=0            |
//|                  .                         |
//|                  ExtFractalEnd=1                     |
//|                                                                         |
//|ExtFiboChoice -       .   |
//|                    0  11                     |
//|                                                                         |
//|ExtFiboZigZag -   "ZiaZag Fibonacci"                       |
//|                                                                         |
//|ExtDelta - .            |
//|                 ,         |
//|                .         |
//|             .   0<ExtDelta<1      |
//|                                                                         |
//|ExtDeltaType -    0 -    " "       |
//|                         2                 |
//|                  1 -   (%- )<ExtDelta        |
//|                  2 - ((%- )/ )<ExtDelta     |
//|                  3 -    " "       |
//|                         3                 |
//|                                                                         |
//|ExtSizeTxt -                                   |
//|                                                                         |
//|ExtLine -                                   |
//|                                                                         |
//|ExtLine886 -               |
//|                                                                         |
//|ExtNotFibo -                                 |
//|                                                                         |
//|ExtPesavento -                                   |
//|                                                                         |
//|ExtGartley886 -    .886              |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|               "Parameters for Gartley Patterns"                         |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|AlgorithmSearchPatterns -            |
//|               ExtIndicator=11                   |
//|           = 0 -   ExtIndicator=0 -    |
//|             124  ZUP   ExtIndicator=11         |
//|    >0    124                            |
//|           = 1 -   ExtIndicator=1 -    |
//|                                               |
//|           = 2 -   ExtIndicator=1 -    |
//|                                             |
//|           = 3 -   ExtIndicator=2                  |
//|           = 4 -   ExtIndicator=4                  |
//|           = 5 -   ExtIndicator=5                  |
//|           = 6 -   ExtIndicator=12                 |
//|                                                                         |
//|PotencialsLevels_retXD -     XD          |
//|             .                      |
//|             ExtIndicator=11  ,        |
//|                   C     |
//|           = 0 -                        |
//|           = 1 -         |
//|            ExtGartleyOnOff=true                                      |
//|           = 2 -   .       |
//|                                                           |
//|                                                                         |
//|visibleLevelsABCD -                  |
//|             D       |
//|           0 -    .                    |
//|           1 -        BD   |
//|           2 -        AB=CD     |
//|           3 -     BD   AB=CD|
//|                                                                         |
//|maxDepth -   Depth (minBars),         |
//|             Depth       |
//|              Gartley                                  |
//|             AlgorithmSearchPatterns=0                     |
//|minDepth -    Depth           |
//|           Gartley.                                                      |
//|                                                                         |
//|FiboStep -          |
//|           Backstep   Backstep=Depth*1.618                      |
//|IterationStepDepth -     Depth      |
//|                 Gartley.                                       |
//|                                                                         |
//|maxSize_  -      .                |
//|                       |
//|            AlgorithmSearchPatterns=1                                    |
//|            AlgorithmSearchPatterns=3                                    |
//|            AlgorithmSearchPatterns=4                                    |
//|            AlgorithmSearchPatterns=6                                    |
//|minSize_  -      .                 |
//|                                                                         |
//|IterationStepSize -     Size        |
//|                 Gartley.                                       |
//|                                                                         |
//|maxPercent_ -         |
//|                       |
//|            AlgorithmSearchPatterns=2                                    |
//|minPercent_ -          |
//|                                                                         |
//|IterationStepPercent -  ()    Percent |
//|                                                                         |
//|DirectionOfSearchMaxMin -   :                     |
//|           false -  minDepth  maxDepth                                |
//|           true -  maxDepth  minDepth                                 |
//|                                                                         |
//|SelectPattern -   5                |
//|           ""  "" ".                             |
//|                                                                         |
//|           0 -                                         |
//|           1 -     - Gartle, Butterfly,  |
//|               Bat, Crab,  TOTAL                                    |
//|           2 -     ,          |
//|                TOTAL                                               |
//|           3 -      ,|
//|                TOTAL                                               |
//|           4 -   ,  TOTAL                   |
//|           5 -   ,  TOTAL                         |
//|           6 -   TOTAL                                        |
//|           7 -            |
//|                  visiblePattern                        |
//|           8 -                         |
//|                                                                         |
//|visiblePattern - ,   .                          |
//|                    .               |
//|                                                                         |
//|NumberPattern -  ,              |
//|                   InfoTF                 |
//|           0 -                      |
//|               ExtIndicator=0                                            |
//|                                                                         |
//|ExtGartleyTypeSearch -                               |
//|           0 -           |
//|           1 -     ,                |
//|                maxBarToD.            |
//|                                                         |
//|           2 -     ,                |
//|                maxBarToD.       |
//|                                                                         |
//|ExtHiddenPP -     ExtIndicator==11             |
//|           0 -   .                 |
//|                .    .          |
//|           1 -    ,       |
//|                NumberPattern.       |
//|                .                                          |
//|           2 -   .                 |
//|                .           |
//|                  Gartley                              |
//|                                                                         |
//|ExtGartleyOnOff -    Gartley.    .|
//|                                                                         |
//|maxBarToD -                   |
//|              D                                           |
//|                                                                         |
//|patternInfluence - 0 -  ,         |
//|                       D   maxBarToD            |
//|                   1 -                  |
//|                      maxBarToD               |
//|                   2 -         |
//|                                                                  |
//|                                                                         |
//|patternTrue = true -  ,  :        |
//|           D          |
//|       ,          |
//|       D;                                               |
//|           D             |
//|       ,            |
//|       D.                                               |
//|                                                                         |
//|                                                                         |
//|AllowedBandPatternInfluence -                |
//|                      X  D .          |
//|                        D            |
//|                   ,              |
//|                                                            |
//|                                                                         |
//|RangeForPointD -      D                   |
//|                                                                         |
//|OldNewRangeForPointD -       D   |
//|                                                                 |
//|                                                                         |
//|ExtColorRangeForPointD -      D                |
//|                                                                         |
//|VectorOfAMirrorTrend  = 1                           |
//|VectorOfAMirrorTrend  = 2                |
//|VectorOfAMirrorTrendColor -                |
//|VectorOfAMirrorTrendStyle -               |
//|                                                                         |
//|shortNamePatterns -           |
//|                                                                         |
//|visibleLineOrTriangle -         |
//|            ,   AB=CD                         |
//|PatternLineStyle -       ABCD      |
//|PatternLineWidth -       ABCD    |
//|ExtColorPatterns -                                          |
//|ExtColorPatternList -              |
//|                       Gartley.        |
//|                       .               |
//|                        ,        |
//|                                                              |
//|                                                                         |
//|ExtDeltaGartley -                |
//|                    9% - 0.09                                 |
//|ExtDeltaGartleyPRZ  -         |
//|                        D                                   |
//|                                                                         |
//|levelD -       XD       |
//|                             |
//|                                                                         |
//|colorLevelD -     XD                        |
//|                                                                         |
//|Equilibrium -    Equilibrium, Reaction1  Reaction2    |
//|ReactionType -                                      |
//|EquilibriumStyle -                                       |
//|EquilibriumWidth -                                     |
//|ColorEquilibrium -    Equilibrium                           |
//|ColorReaction -    Reaction1  Reaction2                    |
//|                                                                         |
//|Ext_3Drives -    3 Drives                          |
//|Ext_xO -     7-  3 Drives     |
//|                                                                         |
//|Dragon -    Dragon                                 |
//|PeakZZDragon -    ,                |
//|                  Dragon                        |
//|                                                                         |
//|Ext_4PointPattern -   4-      |
//|_maxXB -     XB                     |
//|      : http://kanetrading.com/            |
//|                                                                         |
//|ABCD -    AB=CD                                   |
//|      0 -  AB=CD                                      |
//|      1 -   AB=CD                                          |
//|      2 -    AB=CD,                    |
//|                         |
//|searchABCDAlternate -     AB=CD     |
//|ABCDAlternate -     ABCD.      |
//|                    X       |
//|                X*AB=CD                                           |
//|visibleABCDrayZZ -    ABCD              |
//|                                                                         |
//|Ext_noname -     ,        |
//|                  - ""        |
//|                                                                         |
//|CustomPattern -          |
//|0 -                                    |
//|1 -                                     |
//|2 -                                |
//|NameCustomPattern -                     |
//|minXB -     XB                       |
//|maxXB -     XB                      |
//|minAC -     AC                       |
//|maxAC -     AC                      |
//|minBD -     BD                       |
//|maxBD -     BD                      |
//|minXD -     XD                       |
//|maxXD -   Equilibrium  XD           |
//|                       |
//|                                                                         |
//|filtrEquilibrium -     ,     |
//|         X  B .   ,         |
//|        ,          C |
//|            D.                                      |
//|                    |
//|        noname.                                                          |
//|                                                                         |
//|readFromFileListPatterns -             |
//|       \\ZUP\ListPatterns\listpatterns.csv                               |
//|       0 -                          |
//|       1 -            |
//|           ,                        |
//|       2 -    ZUP                |
//|               .            |
//|              .                        |
//|                                                                         |
//|NameFileListPatterns -   .csv       |
//|                                                |
//|                                                                         |
//|writeToFileListPatterns -     :|
//|       1)  readFromFileListPatterns=0                                |
//|           : \\ZUP\ListPatterns\listpatternsdefault.csv             |
//|       2)  readFromFileListPatterns=1                                |
//|           : \\ZUP\ListPatterns\listpatternscustom.csv              |
//|       3)  readFromFileListPatterns=2                                |
//|           : \\ZUP\ListPatterns\listpatternsmixt.csv                |
//|                                                                         |
//|picture -                    |
//|                                                                         |
//|writeInfoPatternsToFileXML -     .XML       |
//|                                            |
//|       0 -                                   |
//|       1 -                      |
//|       2 -                 |
//|                                                                         |
//|writeInfoPatternsToFileCSV -     .CSV       |
//|                                            |
//|       0 -                                   |
//|       1 -                      |
//|       2 -                 |
//|                                                                         |
//|namefileSymbolPeriod = true -           |
//|             Symbol()+"_"+Period()+"_Patterns |
//|                                                                         |
//|InfoPointD -      D         |
//|                                                                  |
//|                                                                         |
//|MonitorPatterns -                                |
//|                                                                         |
//|TextSize -                           |
//|                                                                         |
//|ExtGlobalVariableSet -               |
//|                                            |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|               "Parameters Exp"                                          |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|chHL     = true     -                |
//|                      ExtIdicator=1, ExtIdicator=2, ExtIdicator=3        |
//|                                                                         |
//|PeakDet  = true     -            |
//|                       ExtIndicator                               |
//|                                                                         |
//|chHL_PeakDet - true -                      |
//|  ( )     ZigZag.    |
//|                                                                         |
//|ExtLabel =0                                    |
//|         =1                  |
//|              DT -                          |
//|         =3                  |
//|              DT -                            |
//|                                                                         |
//|ExtCodLabel -                                    |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|                                                                         |
//|               "Common Parameters"                                       |
//|                                                                         |
//|-------------------------------------------------------------------------|
//|ExtFiboType - ,          |
//|                                                                         |
//|               0 -                                        |
//|               1 -      ..                       |
//|               2 - ,                            |
//|                                                                         |
//|ExtFiboTypeFree -                   |
//|                                                                         |
//|ExtObjectColor -   ,       |
//|ExtObjectStyle -  c ,      |
//|ExtObjectWidth -   ,    |
//|                                                                         |
//|ExtDinamic -         |
//|                                 |
//|                           |
//|                                                                         |
//|ExtVisibleDinamic -  ,                  |
//|                                   |
//|                                                                         |
//|                   :                |
//|             1 -                                |
//|             2 -            |
//|                                                                         |
//|               ExtVisibleDinamic = "01"                       |
//|             0 -                              |
//|             1 -                             |
//|                                                                         |
//|RefreshStaticNewRayZZ -       |
//|                          |
//|              .                                                |
//|                                                                         |
//|ZigZagHighLow - ,                      |
//|                   ..                  |
//|            true -                                     |
//|            false -   ZigZag,     ""     |
//|                                                                         |
//|ExtSendMail -    email   .        |
//|                                                                         |
//|ExtAlert -                    |
//|              ZigZag                              |
//|                                                                         |
//|ExtPlayAlert -                |
//|                                                  |
//|                                                                         |
//|AlertText -                  |
//|                                                                         |
//|ExtBack -                                |
//|                                                                         |
//|ExtSave -                     |
//|          Fibo Time                                                      |
//|                                                                         |
//|info_comment -             |
//|                  .                           |
//|             5  .                                    |
//|            0 -                               |
//|            1 -                                 |
//|                                                                         |
//|             :                                           |
//|            1 -                     |
//|            2 - %                          |
//|            3 -                                         |
//|            4 -     Gartley                  |
//|                                                                         |
//|infoMerrillPattern - true -                  |
//|                     false -               |
//|                                                                         |
//|infoTF -    5  .( )       |
//|           .    .      |
//|             .                   |
//|                .    |
//|               .        |
//|            Gartley         |
//|            D   Gartley.              |
//|                                                                         |
//|        Gartley     |
//|                                                           |
//|bigText -                |
//|                |
//|bigTextSize -                                          |
//|bigTextColor -    ( Gartley Bullish )         |
//|bigTextColorBearish -     Gartley Bearish    |
//|bigTextX -                    |
//|bigTextY -                      |
//|                                                                         |
//|ExtVisible -   ZUP                    |
//|ExtComplekt -   .        |
//|                    .      |
//|                     .    |
//+-------------------------------------------------------------------------+